"""
The hEdgeBottom, sEdgeRight, bEdgeLeft, andAngle, lessThanAngle and
greaterThanAngle Connection Functions
"""

INPUT_NEURONS_HEIGHT = 50
INPUT_NEURONS_WIDTH = 50

DELAY = 1.0

#----------setup connections 3x3 on to HEdgeTop (top of a solid)
#---2 on either side self and row above 10 
def set6x6OnToHedgeTopConnections(Col,Row):
    weight = 3.0
    #don't input off top
    if (Row == 0): return []
    #don't output off bottom
    if (Row == INPUT_NEURONS_HEIGHT): return []
    connector = []
    toNeuron = (Row)*50+Col
    startAddCol = Col-2
    if (startAddCol < 0): startAddCol = 0
    endAddCol = Col+3
    if (endAddCol > INPUT_NEURONS_WIDTH): endAddCol = INPUT_NEURONS_WIDTH
    for addCol in range (startAddCol,endAddCol):
        fromNeuron = (Row*50)+addCol
        newConnector = [(fromNeuron, toNeuron, weight, DELAY)]
        connector = connector + newConnector
    return connector

#----------setup connections 6x6off to HEdgeTop (top of a solid)
def set6x6OffToHedgeTopConnections(Col,Row):
    weight = 4.0
    #don't input off top
    if (Row == 0): return []
    #don't output off bottom
    if (Row == INPUT_NEURONS_HEIGHT): return []
    connector = []
    toNeuron = (Row)*50+Col
    startAddCol = Col-2
    if (startAddCol < 0): startAddCol = 0
    endAddCol = Col+3
    if (endAddCol > INPUT_NEURONS_WIDTH): endAddCol = INPUT_NEURONS_WIDTH
    for addCol in range (startAddCol,endAddCol):
        fromNeuron = (Row*50)+addCol
        newConnector = [(fromNeuron, toNeuron, weight, DELAY)]
        connector = connector + newConnector
    return connector

#----------setup connections 6x6 on to HEdgeBottom (bottom of a solid)
def set6x6OnToHedgeBottomConnections(Col,Row):
    weight = 3.0
    #don't input off top
    if (Row == 0): return []
    #don't output off bottom
    if (Row == INPUT_NEURONS_HEIGHT): return []
    connector = []
    toNeuron = (Row)*50+Col
    startAddCol = Col-2
    if (startAddCol < 0): startAddCol = 0
    endAddCol = Col+3
    if (endAddCol > INPUT_NEURONS_WIDTH): endAddCol = INPUT_NEURONS_WIDTH
    for addCol in range (startAddCol,endAddCol):
        fromNeuron = ((Row-1)*50)+addCol
        newConnector = [(fromNeuron, toNeuron, weight, DELAY)]
        connector = connector + newConnector
    return connector

#----------setup connections 6x6off to HEdgeBottom (bottom of a solid)
def set6x6OffToHedgeBottomConnections(Col,Row):
    weight = 3.0
    #don't input off top
    if (Row == 0): return []
    #don't output off bottom
    if (Row == INPUT_NEURONS_HEIGHT): return []
    connector = []
    toNeuron = (Row)*50+Col
    startAddCol = Col-2
    if (startAddCol < 0): startAddCol = 0
    endAddCol = Col+3
    if (endAddCol > INPUT_NEURONS_WIDTH): endAddCol = INPUT_NEURONS_WIDTH
    for addCol in range (startAddCol,endAddCol):
        fromNeuron = ((Row+1)*50)+addCol
        newConnector = [(fromNeuron, toNeuron, weight, DELAY)]
        connector = connector + newConnector
    return connector

#----------setup connections 6x6 to SEdgeRight (right of a solid)
#connections from self one to right then 3 above 2 below sloping
def set6x6OnToSedgeRightConnections(Col,Row):
    if (Row <3): return []
    if (Row > INPUT_NEURONS_HEIGHT -3): return []
    if (Col < 2): return []
    if (Col > INPUT_NEURONS_WIDTH -4): return []

    weight = 4.0
    inhibWeight = -4.0 # inhibit right sEdges well to the rigft
    toNeuron = (Row)*50+Col
    row1Off = (Row-3)*INPUT_NEURONS_WIDTH + Col+3
    row1Left = (Row-3)*INPUT_NEURONS_WIDTH + Col+2
    row1Right = (Row-3)*INPUT_NEURONS_WIDTH + Col+1
    row2Off = (Row-2)*INPUT_NEURONS_WIDTH + Col+2
    row2Left = (Row-2)*INPUT_NEURONS_WIDTH + Col+1
    row2Right = (Row-2)*INPUT_NEURONS_WIDTH + Col
    row3Off = (Row-1)*INPUT_NEURONS_WIDTH + Col+2
    row3Left = (Row-1)*INPUT_NEURONS_WIDTH + Col+1
    row3Right = (Row-1)*INPUT_NEURONS_WIDTH + Col
    ownRowOff = Row*INPUT_NEURONS_WIDTH + Col+1
    ownRowLeft = toNeuron
    ownRowRight = toNeuron - 1
    row5Off = (Row+1)*INPUT_NEURONS_WIDTH + Col+1
    row5Left = (Row+1)*INPUT_NEURONS_WIDTH + Col
    row5Right = (Row+1)*INPUT_NEURONS_WIDTH + Col-1
    row6Off = (Row+2)*INPUT_NEURONS_WIDTH + Col
    row6Left = (Row+2)*INPUT_NEURONS_WIDTH + Col-1
    row6Right = (Row+2)*INPUT_NEURONS_WIDTH + Col-2
    connector = [
        (row1Off, toNeuron, inhibWeight, DELAY),
        (row1Left, toNeuron, weight, DELAY),
        (row1Right, toNeuron, weight, DELAY),
        (row2Off, toNeuron, inhibWeight, DELAY),
        (row2Left, toNeuron, weight, DELAY),
        (row2Right, toNeuron, weight, DELAY),
        (row3Off, toNeuron, inhibWeight, DELAY),
        (row3Left, toNeuron, weight, DELAY),
        (row3Right, toNeuron, weight, DELAY),        
        (ownRowOff, toNeuron, inhibWeight, DELAY),
        (ownRowLeft, toNeuron, weight, DELAY),
        (ownRowRight, toNeuron, weight, DELAY),
        (row5Off, toNeuron, inhibWeight, DELAY),
        (row5Left, toNeuron, weight, DELAY),
        (row5Right, toNeuron, weight, DELAY),        
        (row6Off, toNeuron, inhibWeight, DELAY),
        (row6Left, toNeuron, weight, DELAY),
        (row6Right, toNeuron, weight, DELAY)]
    return connector

#----------setup connections 6x6 on to BEdgeLeft (left of a solid)
#connections from self one to left then 3 above 2 below sloping
def set6x6OnToBedgeLeftConnections(Col,Row):
    if (Row < 3): return []
    if (Row > INPUT_NEURONS_HEIGHT -3): return []
    if (Col < 3): return []
    if (Col > INPUT_NEURONS_WIDTH -3): return []

    weight = 4.0
    inhibWeight = -4.0 # inhibit things well to the left
    toNeuron = (Row)*50+Col
    row1Off = (Row-3)*INPUT_NEURONS_WIDTH + Col-3
    row1Left = (Row-3)*INPUT_NEURONS_WIDTH + Col-2
    row1Right = (Row-3)*INPUT_NEURONS_WIDTH + Col-1
    row2Off = (Row-2)*INPUT_NEURONS_WIDTH + Col-2
    row2Left = (Row-2)*INPUT_NEURONS_WIDTH + Col-1
    row2Right = (Row-2)*INPUT_NEURONS_WIDTH + Col
    row3Off = (Row-1)*INPUT_NEURONS_WIDTH + Col-2
    row3Left = (Row-1)*INPUT_NEURONS_WIDTH + Col-1
    row3Right = (Row-1)*INPUT_NEURONS_WIDTH + Col
    ownRowOff = Row*INPUT_NEURONS_WIDTH + Col-1
    ownRowLeft = toNeuron
    ownRowRight = toNeuron + 1
    row5Off = (Row+1)*INPUT_NEURONS_WIDTH + Col-1
    row5Left = (Row+1)*INPUT_NEURONS_WIDTH + Col
    row5Right = (Row+1)*INPUT_NEURONS_WIDTH + Col+1
    row6Off = (Row+2)*INPUT_NEURONS_WIDTH + Col
    row6Left = (Row+2)*INPUT_NEURONS_WIDTH + Col+1
    row6Right = (Row+2)*INPUT_NEURONS_WIDTH + Col+2
    connector = [
        (row1Off, toNeuron, inhibWeight, DELAY),
        (row1Left, toNeuron, weight, DELAY),
        (row1Right, toNeuron, weight, DELAY),
        (row2Off, toNeuron, inhibWeight, DELAY),
        (row2Left, toNeuron, weight, DELAY),
        (row2Right, toNeuron, weight, DELAY),
        (row3Off, toNeuron, inhibWeight, DELAY),
        (row3Left, toNeuron, weight, DELAY),
        (row3Right, toNeuron, weight, DELAY),        
        (ownRowOff, toNeuron, inhibWeight, DELAY),
        (ownRowLeft, toNeuron, weight, DELAY),
        (ownRowRight, toNeuron, weight, DELAY),
        (row5Off, toNeuron, inhibWeight, DELAY),
        (row5Left, toNeuron, weight, DELAY),
        (row5Right, toNeuron, weight, DELAY),        
        (row6Off, toNeuron, inhibWeight, DELAY),
        (row6Left, toNeuron, weight, DELAY),
        (row6Right, toNeuron, weight, DELAY)]
    return connector


#----------setup connections 3x3 on to And Angle 
#connections from self to above two rows and on either side for 6 in total
def set3x3OnToAndAngleConnections(Col,Row):
    if (Row > INPUT_NEURONS_HEIGHT -3): return []
    if (Col < 1): return []
    if (Col > INPUT_NEURONS_WIDTH-2): return []

    weight = 7.0

    toNeuron = (Row*50)+Col
    connector = []
    for addRow in range (Row+1,Row+3):
      for addCol in range (Col-1,Col+2):
        fromNeuron = ((addRow)*50)+addCol
        newConnector = [(fromNeuron, toNeuron, weight, DELAY)]
        connector = connector + newConnector
    return connector

#connect 9x9off inhib from  two to the left and right (5)
def set9x9OffToAndAngleConnections(Col,Row):
    if (Col < 2): return []
    if (Col > INPUT_NEURONS_WIDTH-3): return []

    inhibWeight = -4.0

    toNeuron = (Row*50)+Col
    fromInhibNeuron = (Row*50)+Col-2
    connector = [
        (fromInhibNeuron, toNeuron, inhibWeight, DELAY),
        (fromInhibNeuron+1, toNeuron, inhibWeight, DELAY),
        (fromInhibNeuron+2, toNeuron, inhibWeight, DELAY),
        (fromInhibNeuron+3, toNeuron, inhibWeight, DELAY),
        (fromInhibNeuron+4, toNeuron, inhibWeight, DELAY)]

    return connector

#----------setup connections 3x3 on to Less Than Angle 
#connections from self and from right two cols and row on either side to self 7
def set3x3OnToLessThanAngleConnections(Col,Row):
    if (Row < 1): return []
    if (Row > INPUT_NEURONS_HEIGHT-2): return []
    if (Col > INPUT_NEURONS_WIDTH-3): return []

    weight = 4.0

    toNeuron = (Row*50)+Col
    fromNeuron = toNeuron
    connector =  [(fromNeuron,toNeuron,weight,DELAY)]
    for addRow in range (Row-1,Row+2):
      for addCol in range (Col+1,Col+3):
        fromNeuron = ((addRow)*50)+addCol
        newConnector = [(fromNeuron, toNeuron, weight, DELAY)]
        connector = connector + newConnector
    return connector

#connect 9x9off excite self inhib from  two to the left for 3 rows around (9)
def set9x9OffToLessThanAngleConnections(Col,Row):
    if (Row < 1): return []
    if (Row > INPUT_NEURONS_HEIGHT-2): return []
    if (Col < 2): return []

    weight = 5.0
    inhibWeight = -3.0

    toNeuron = (Row*50)+Col
    connector = []
    for addRow in range (Row-1,Row+2):
        fromNeuron = ((addRow)*50)+Col
        newConnectors = [(fromNeuron, toNeuron, weight, DELAY),
                        (fromNeuron-1, toNeuron, inhibWeight, DELAY),
                        (fromNeuron-2, toNeuron, inhibWeight, DELAY)]
        connector = connector + newConnectors
    return connector




#----------setup connections 3x3 on to And Angle 
#conns from self and from right left cols and row on either side to self 7
def set3x3OnToGreaterThanAngleConnections(Col,Row):
    if (Row < 1): return []
    if (Row > INPUT_NEURONS_HEIGHT-2): return []
    if (Col < 1): return []
    if (Col > INPUT_NEURONS_WIDTH-1): return []

    weight = 4.0

    toNeuron = (Row*50)+Col
    fromNeuron = toNeuron+1
    connector =  [(fromNeuron,toNeuron,weight,DELAY)]
    for addRow in range (Row-1,Row+2):
      for addCol in range (Col-1,Col+1):
        fromNeuron = ((addRow)*50)+addCol
        newConnector = [(fromNeuron, toNeuron, weight, DELAY)]
        connector = connector + newConnector
    return connector

#connect 9x9off excite from left inhib from self and right for 3 rows around(9)
def set9x9OffToGreaterThanAngleConnections(Col,Row):
    if (Row < 1): return []
    if (Row > INPUT_NEURONS_HEIGHT-2): return []
    if (Col < 2): return []
#    if (Col > INPUT_NEURONS_WIDTH-2): return []

    weight = 5.0
    inhibWeight = -1.0

    toNeuron = (Row*50)+Col
    connector = []
    for addRow in range (Row-1,Row+2):
        fromNeuron = ((addRow)*50)+Col
        newConnectors = [(fromNeuron-2, toNeuron, weight, DELAY),
                        (fromNeuron-1, toNeuron, inhibWeight, DELAY),
                        (fromNeuron, toNeuron, inhibWeight, DELAY)]
        connector = connector + newConnectors
    return connector


